variables:
  CONTAINER_REGISTRY: registry.gitlab.com
  CONTAINER_IMAGE_NAME: ai/rs_text_recognition_worker
  MEDIA_FEATURE_DEPENDENCIES: "clang libavutil-dev libavdevice-dev libavfilter-dev libavformat-dev libavresample-dev libpostproc-dev libswresample-dev ffmpeg"
  TESSERACT_FEATURE_DEPENDANCIES: "libleptonica-dev libtesseract-dev"

stages:
  - test
  - publish

include:
  - project: 'media-cloud-ai/ci/pipelines'
    file: '/rust/rust-publish-docker.yml'
  - project: 'media-cloud-ai/ci/pipelines'
    file: '/rust/rust-base.yml'

build:test:
  stage: test
  before_script:
    - apt-get update -q && apt-get install ${MEDIA_FEATURE_DEPENDENCIES} ${TESSERACT_FEATURE_DEPENDANCIES} -y
  script: cargo test

build:format:
  stage: test
  before_script:
    - apt-get update -q && apt-get install ${MEDIA_FEATURE_DEPENDENCIES} ${TESSERACT_FEATURE_DEPENDANCIES} -y
  script: cargo fmt -- --check

build:clippy:
  stage: test
  before_script:
    - apt-get update -q && apt-get install ${MEDIA_FEATURE_DEPENDENCIES} ${TESSERACT_FEATURE_DEPENDANCIES} -y
  script: cargo clippy --all-targets --all-features -- -D warnings

build:coverage:
  stage: test
  before_script:
    - apt-get update -q && apt-get install ${MEDIA_FEATURE_DEPENDENCIES} ${TESSERACT_FEATURE_DEPENDANCIES} -y
  script: cargo tarpaulin --avoid-cfg-tarpaulin --out Xml --all-features
  after_script:
    - apt-get install -y curl
    - bash <(curl -s https://codecov.io/bash)
  coverage: '/^\d+.\d+% coverage/'
